#include "auto.h"

/************************************************************************/
/*			PRIVATE FUNCTIONS				*/
/************************************************************************/
void PaintAbortWidget (SUIT_object obj);
void HitAbortWidget (SUIT_object obj, SUIT_event ev);
void HitAbortWidget2 (SUIT_object obj);
void HitAbortButton (SUIT_object obj, SUIT_event ev);


/************************************************************************/
/* User defined  SUIT objects						*/
/************************************************************************/


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name: 	CreateAbortWidget				*/
/* 									*/
/* Description:		create a new instance of the graphics widget	*/
/*			for displaying Abort-nets			*/
/* 									*/
/* Date of creation:	16-10-92					*/
/* 									*/
/* input arguments:	name of widget					*/
/* 									*/
/* output:		None						*/
/* 									*/
/* function return:	pointer to new SUIT object			*/
/* 									*/
/* Modifications:							*/
/* 									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

SUIT_object CreateAbortWidget (char *name)
{
  SUIT_object button_obj;

  button_obj = SUIT_createButton (name, HitAbortWidget2);
  SUIT_setColor (button_obj, FOREGROUND_COLOR, GP_defColor ("white"));
  SUIT_setColor (button_obj, BACKGROUND_COLOR, GP_defColor ("red"));
  SUIT_setText (button_obj, LABEL, "STOP");
  SUIT_makePropertyTemporary (button_obj, LABEL, OBJECT);
  SUIT_setBoolean (button_obj, ABORTED, FALSE);
  SUIT_setBoolean (button_obj, SHRINK_TO_FIT, FALSE);

  SUIT_makePropertyTemporary (button_obj, ABORTED, OBJECT);
  SUIT_makePropertyTemporary (button_obj, FOREGROUND_COLOR, OBJECT);
  SUIT_makePropertyTemporary (button_obj, BACKGROUND_COLOR, OBJECT);

  return (button_obj);
}

void HitAbortWidget2 (SUIT_object obj)
{
  SUIT_setBoolean (obj, ABORTED, TRUE);
}
