#include "auto.h"
#include "patchlevel.h"


/************************************************************************/
/*			PRIVATE FUNCTIONS				*/
/************************************************************************/
int isnt_space (char ch);



/************************************************************************/
/*			THE FUNCTIONS					*/
/************************************************************************/

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void set_colour (char *colour)
{
  GP_setColor (GP_defColor (colour, FALSE));
}



/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void set_therm_color (int level)
{
  if (level > MAX_THERM_COLORS)
    level = MAX_THERM_COLORS;
  if (level < 0)
    level = 0;

  set_colour (thermo_colors[level]);
}

void set_gray (int level)
{
  if (level > MAX_COLORS)
    level = MAX_COLORS;
  if (level < 0)
    level = 0;

  set_colour (my_colors[level]);
}



/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void GNU_thing ()
{
  puts ( PROGRAM " version " PATCHLEVEL " Copyright (C) 1993 Sunil Gupta");
  puts ( PROGRAM " comes with ABSOLUTELY NO WARRANTY ");
  puts ("This is free software, and you are welcome to redistribute it");
  puts ("under certain conditions");
  puts ("See the file LICENSE for more details");
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:	reset_row_col					*/
/*									*/
/* Description:		change number of rows + columns in automata	*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void
  reset_row_col (SUIT_object auto_obj, int new_rows, int new_cols)
{
  automaton automata;

  ENTER("reset_row_col");

  automata = (automaton) SUITx_getVoidPtr (auto_obj, AUTOMATON);
  free (automata);

  automata = AllocateAutomaton (new_rows, new_cols);

  SUITx_setVoidPtr (auto_obj, AUTOMATON, automata);
  SUIT_setInteger (auto_obj, ROWS, new_rows);
  SUIT_setInteger (auto_obj, COLUMNS, new_cols);
  ClearAutomatonStacks (auto_obj);

  SUIT_setBoolean(auto_obj,HAS_BACKGROUND,TRUE);
  SUIT_paintObject (auto_obj);
  SUIT_setBoolean(auto_obj,HAS_BACKGROUND,FALSE);

  LEAVE("reset_row_col");
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:		returns index of element in array so as to 	*/
/*			appear to be an infinite plane			*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
#   define CHECK_LIMITS(num,limit)	\
   {					\
        while (num >= limit)		\
          num -= limit;			\
        while (num < 0)			\
          num += limit;			\
   }

int
  get_item (int row, int col)
{
  int retval;

  CHECK_LIMITS (row, rows);
  CHECK_LIMITS (col, cols);

  retval = (row * cols) + col;

  return (retval);
}

void get_rowCol (int item, int *row, int *col)
{
  *row = item / cols;
  *col = item - (*row * cols);
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void trim (char *str, char **start)
{
  char *end, *first;

  *start = str;

  if (*str)
  {
    /* -------------------------------------------------------- */
    /* locate first non space character                         */
    /* -------------------------------------------------------- */
    first = str;
    while (*first == ' ')
      first++;

    /* -------------------------------------------------------- */
    /* find end of string                                       */
    /* -------------------------------------------------------- */
    end = first;
    while (*end)
      end++;

    /* -------------------------------------------------------- */
    /* locate last non space character                          */
    /* -------------------------------------------------------- */
    while (!isnt_space (*end) && (end > first))
      end--;

    if (isnt_space (*end))
      end++;

    *end = 0;

    *start = first;

  }
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
int isnt_space (char ch)
{
  return ((ch > 32) && (ch < 127));
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
char *skiptonum (char *ch)
{
  while (*ch && isdigit (*ch))
    ch++;

  while (*ch && !isdigit (*ch))
    ch++;

  return (ch);
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void setfont (SUIT_object obj, char *name, char *style, double size)
{
  SUIT_setFont (obj, FONT, GP_defFont (name, style, size));
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void do_state_typein (SUIT_object auto_obj)
{
  char buffer[200];
  int rows, cols, states;
  SUIT_object state_obj, rows_obj, cols_obj, color_obj;

  rows = SUIT_getInteger (auto_obj, ROWS);
  cols = SUIT_getInteger (auto_obj, COLUMNS);
  states = SUIT_getInteger (auto_obj, STATES);

  state_obj = SUIT_getObject (auto_obj, STATEOBJ);
  rows_obj = SUIT_getObject (auto_obj, ROWSOBJ);
  cols_obj = SUIT_getObject (auto_obj, COLSOBJ);
  ClearAutomatonStacks (auto_obj);

  color_obj = SUIT_getObject (state_obj, COLOROBJ);

  SUIT_setInteger (color_obj, CSTATES, states);

  sprintf (buffer, "%d", states);
  SUIT_setText (state_obj, CURRENT_VALUE, buffer);

  sprintf (buffer, "%d", rows);
  SUIT_setText (rows_obj, CURRENT_VALUE, buffer);

  sprintf (buffer, "%d", cols);
  SUIT_setText (cols_obj, CURRENT_VALUE, buffer);

}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
DynArray set_object_to_check (SUIT_object abort_obj)
{
  DynArray dyn_list;

  dyn_list = DynCreate (sizeof (SUIT_object), 1);
  DynAdd (dyn_list, (void *) &abort_obj);

  return (dyn_list);
}
