/* SUIT version 2.3 */

#define THE_SCREEN_WIDTH 960
#define THE_SCREEN_HEIGHT 600
#define THE_SCREEN_DEPTH 7

#include "suit.h"


/*--------------------------------------------------------------------------------*/
/*                                                                                */
/*                                  NOTE:                                         */
/*                                                                                */
/*    This file contains all the permanent properties of this application's       */
/*    objects and is read in as a data file.  Compiling this file as part of      */
/*    your application "hard codes" your interface.  Please see "shipping"        */
/*    in the SUIT reference manual for further information.                       */
/*                                                                                */
/*                                                                                */
/*                              !! DANGER !!                                      */
/*                                                                                */
/*      This file is machine-generated, and its contents are very important.      */
/*                                                                                */
/*          If you must edit this file, do so with extreme caution!               */
/*                                                                                */
/*                              !! DANGER !!                                      */
/*                                                                                */
/*--------------------------------------------------------------------------------*/


extern void SUIT_interiorInitFromCode (char *programName, SUIT_functionPointer suiRoutine,
                                       int width, int height, int depth);

extern SUIT_type *si_getType(char *typeName);

extern void si_addChildToObject(SUIT_object, SUIT_object, boolean);

static void MAKE (char *name, char *class, char *parent, boolean interactive) 
{ 
    SUIT_object o = SUIT_name(name); 
    SUIT_object p = SUIT_name(parent); 
    if (p != NULL) {
        if (o == NULL) 
            o = SUIT_createObjectByClass(name, class); 
    	if (interactive) {
    	    SUIT_setBoolean (o, INTERACTIVELY_CREATED, TRUE);
    	    SUIT_makePropertyTemporary (o, INTERACTIVELY_CREATED, OBJECT);
    	}
        si_addChildToObject(SUIT_name(parent), o, FALSE); 
    }
} 
 


static void SET (char *objOrClass, char *propertyName, char *propertyType, boolean atClass,
                 boolean locked, char *stringValue) 
{ 
    SUIT_type	*type; 
    boolean	errorStatus; 
    Pointer	retval; 
    SUIT_level level = OBJECT; 
    SUIT_object o; 
     
    if (atClass) 
        level = CLASS; 
    if (level == CLASS) 
        o = SUIT_dummyObjectInClass(objOrClass); 
    else 
        o = SUIT_name(objOrClass); 
    type = si_getType(propertyType); 
    retval = type->convertFromAscii(stringValue, &errorStatus); 
    if (errorStatus == FALSE) 
	SUIT_setProperty(o, propertyName, propertyType, retval, level); 

    if (locked) 
        SUIT_lockProperty(o, propertyName, level); 
}


static void INIT_suiRoutine(void)
{
/* This line is for parsing simplicity -- do NOT remove it!  @ */
MAKE("Done","button","ROOT",0);
MAKE("Clear Analysis","button","ROOT",0);
MAKE("Analysis","on/off switch","ROOT",0);
MAKE("Core","bulletin board","ROOT",0);
MAKE("Core: graphics","Matrix class","Core",0);
MAKE("Core: text","label","Core",0);
MAKE("Core: colorbar","Colorbar class","Core",0);
MAKE("Active","bulletin board","ROOT",0);
MAKE("Active: graphics","LineGraph class","Active",0);
MAKE("Active: text","label","Active",0);
MAKE("Fired","bulletin board","ROOT",0);
MAKE("Fired: graphics","LineGraph class","Fired",0);
MAKE("Fired: text","label","Fired",0);
MAKE("main: menu: menu","menu","ROOT",0);
MAKE("main: menu: load_auto","button","main: menu: menu",0);
MAKE("main: menu: load_pgm_auto","button","main: menu: menu",0);
MAKE("main: menu: save_auto","button","main: menu: menu",0);
MAKE("main: menu: save_pgm_auto","button","main: menu: menu",0);
MAKE("main","bulletin board","ROOT",0);
MAKE("main: automata","Automata class","main",0);
MAKE("main: rlabel","label","main",0);
MAKE("main: clabel","label","main",0);
MAKE("main: rtype","type in box","main",0);
MAKE("main: slabel","label","main",0);
MAKE("main: ctype","type in box","main",0);
MAKE("main: stype","type in box","main",0);
MAKE("main: grid","on/off switch","main",0);
MAKE("main: step","on/off switch","main",0);
MAKE("main: menu","pulldown menu","main",0);
MAKE("main: clear","button","main",0);
MAKE("main: refresh","button","main",0);
MAKE("main: colorbar","Colorbar class","main",0);
MAKE("main: method","scrollable list","main",0);
MAKE("main: method: scrollbar","bounded value","main: method",0);
MAKE("main: method: list","list","main: method",0);
MAKE("Cellular Automata Simulator","button","ROOT",0);
SET("arrow button","border raised","boolean",1,0,"no");
SET("arrow button","darken background","boolean",1,0,"yes");
SET("arrow button","direction","SUIT_enum",1,0,"\"up\" of {\"up\" \"down\" \"left\" \"right\"}");
SET("arrow button","draw filled","boolean",1,0,"no");
SET("arrow button","has background","boolean",1,0,"no");
SET("arrow button","intermediate feedback","boolean",1,0,"no");
SET("arrow button","shadow thickness","int",1,0,"3");
SET("Automata class","interactively created","boolean",1,0,"no");
SET("bounded value","arrowhead angle","int",1,0,"10");
SET("bounded value","arrowhead length","double",1,0,"0.200000");
SET("bounded value","button background color","GP_color",1,0,"black, black");
SET("bounded value","button foreground color","GP_color",1,0,"grey, white");
SET("bounded value","current value","double",1,0,"0.000000");
SET("bounded value","granularity","double",1,0,"0.000000");
SET("bounded value","has arrow","boolean",1,0,"yes");
SET("bounded value","has tick marks","boolean",1,0,"yes");
SET("bounded value","increase clockwise","boolean",1,0,"yes");
SET("bounded value","interactively created","boolean",1,0,"no");
SET("bounded value","minimum value","double",1,0,"0.000000");
SET("bounded value","needle color","GP_color",1,0,"black, black");
SET("bounded value","start angle","double",1,0,"0.000000");
SET("bulletin board","border raised","boolean",1,0,"no");
SET("bulletin board","interactively created","boolean",1,0,"no");
SET("button","disabled color","GP_color",1,0,"white, white");
SET("button","hotkey","text",1,0,"");
SET("button","interactively created","boolean",1,0,"no");
SET("button","justification","SUIT_enum",1,0,"\"center\" of {\"left\" \"center\" \"right\"}");
SET("button","shrink to fit","boolean",1,0,"yes");
SET("Colorbar class","interactively created","boolean",1,0,"no");
SET("elevator","border raised","boolean",1,0,"no");
SET("elevator","has background","boolean",1,0,"no");
SET("label","has border","boolean",1,0,"no");
SET("label","interactively created","boolean",1,0,"no");
SET("label","justification","SUIT_enum",1,0,"\"center\" of {\"left\" \"center\" \"right\"}");
SET("label","shrink to fit","boolean",1,0,"yes");
SET("LineGraph class","interactively created","boolean",1,0,"no");
SET("list","border raised","boolean",1,0,"no");
SET("list","interactively created","boolean",1,0,"no");
SET("list","text spacing","double",1,0,"1.200000");
SET("Matrix class","interactively created","boolean",1,0,"no");
SET("menu","cache using canvas","boolean",1,0,"yes");
SET("menu","interactively created","boolean",1,0,"no");
SET("on/off switch","disabled color","GP_color",1,0,"white, white");
SET("on/off switch","interactively created","boolean",1,0,"no");
SET("on/off switch","shrink to fit","boolean",1,0,"yes");
SET("pulldown menu","interactively created","boolean",1,0,"no");
SET("scrollable list","border raised","boolean",1,0,"no");
SET("scrollable list","has background","boolean",1,0,"no");
SET("scrollable list","has border","boolean",1,0,"no");
SET("scrollable list","interactively created","boolean",1,0,"no");
SET("type in box","any keystroke triggers","boolean",1,0,"no");
SET("type in box","backward char key","text",1,0,"C-b");
SET("type in box","beginning of line key","text",1,0,"C-a");
SET("type in box","beginning of text key","text",1,0,"M-<");
SET("type in box","border raised","boolean",1,0,"no");
SET("type in box","cursor color","GP_color",1,0,"black, black");
SET("type in box","cursor index","int",1,0,"0");
SET("type in box","cursor style","SUIT_enum",1,0,"\"vertical bar\" of {\"i-beam\" \"vertical bar\"}");
SET("type in box","delete char key","text",1,0,"C-d");
SET("type in box","delete entire line key","text",1,0,"C-u");
SET("type in box","done editing key","text",1,0,"C-x");
SET("type in box","double click time","double",1,0,"400000.000000");
SET("type in box","end of line key","text",1,0,"C-e");
SET("type in box","end of text key","text",1,0,"M->");
SET("type in box","forward char key","text",1,0,"C-f");
SET("type in box","has a tab","boolean",1,0,"no");
SET("type in box","interactively created","boolean",1,0,"no");
SET("type in box","kill line key","text",1,0,"C-k");
SET("type in box","last mark index","int",1,0,"0");
SET("type in box","mark end index","int",1,0,"0");
SET("type in box","mark index","int",1,0,"0");
SET("type in box","newline key","text",1,0,"C-m");
SET("type in box","next line key","text",1,0,"C-n");
SET("type in box","open line key","text",1,0,"C-o");
SET("type in box","pre cursor index","int",1,0,"0");
SET("type in box","previous line key","text",1,0,"C-p");
SET("type in box","repaint key","text",1,0,"C-l");
SET("type in box","scroll down key","text",1,0,"M-v");
SET("type in box","scroll up key","text",1,0,"C-v");
SET("type in box","set mark key","text",1,0,"C-`");
SET("type in box","shrink to fit","boolean",1,0,"yes");
SET("type in box","spacing gap","int",1,0,"3");
SET("type in box","start x","int",1,0,"0");
SET("type in box","start y","double",1,0,"0.000000");
SET("type in box","tab key","text",1,0,"C-i");
SET("type in box","tab length","int",1,0,"5");
SET("type in box","wipe block key","text",1,0,"C-w");
SET("type in box","yank key","text",1,0,"C-y");
SET("ROOT","animated","boolean",0,0,"no");
SET("ROOT","background color","GP_color",0,0,"grey, white");
SET("ROOT","border color","GP_color",0,0,"grey, black");
SET("ROOT","border raised","boolean",0,0,"yes");
SET("ROOT","border type","SUIT_enum",0,0,"\"motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("ROOT","border width","int",0,0,"2");
SET("ROOT","clip to viewport","boolean",0,0,"yes");
SET("ROOT","default object height","int",0,0,"80");
SET("ROOT","default object width","int",0,0,"80");
SET("ROOT","draw border on inside","boolean",0,0,"no");
SET("ROOT","font","GP_font",0,0,"times,,12.000000");
SET("ROOT","foreground color","GP_color",0,0,"black, black");
SET("ROOT","has background","boolean",0,0,"yes");
SET("ROOT","has border","boolean",0,0,"yes");
SET("ROOT","margin","int",0,0,"5");
SET("ROOT","show temporary properties","boolean",0,0,"no");
SET("ROOT","shrink to fit","boolean",0,0,"no");
SET("ROOT","springiness","SUIT_springiness",0,0,"63");
SET("ROOT","SUIT system font","GP_font",0,0,"helvetica,,14.000000");
SET("ROOT","viewport","viewport",0,1,"0 0 959 599");
SET("ROOT","visible","boolean",0,0,"yes");
SET("ROOT","window","window",0,1,"0.000000 0.000000 1.000000 1.000000");
SET("Done","active display","SUIT_enum",0,0,"\"standard\" of {\"button with hotkey\" \"standard\"}");
SET("Done","border raised","boolean",0,0,"yes");
SET("Done","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("Done","disabled","boolean",0,0,"no");
SET("Done","done callback function","SUIT_functionPointer",0,0,"function ptr");
SET("Done","has background","boolean",0,0,"yes");
SET("Done","label","text",0,0,"EXIT");
SET("Done","shrink to fit","boolean",0,0,"no");
SET("Done","viewport","viewport",0,0,"2 2 97 61");
SET("Clear Analysis","active display","SUIT_enum",0,0,"\"standard\" of {\"button with hotkey\" \"standard\"}");
SET("Clear Analysis","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("Clear Analysis","disabled","boolean",0,0,"no");
SET("Clear Analysis","label","text",0,0,"Clear Analysis");
SET("Clear Analysis","shrink to fit","boolean",0,0,"no");
SET("Clear Analysis","viewport","viewport",0,0,"116 501 212 537");
SET("Analysis","active display","SUIT_enum",0,0,"\"motif square\" of {\"dot in circle\" \"check box\" \"motif diamond\" \"motif square\"}");
SET("Analysis","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("Analysis","current value","boolean",0,0,"no");
SET("Analysis","disabled","boolean",0,0,"no");
SET("Analysis","label","text",0,0,"Analysis");
SET("Analysis","shrink to fit","boolean",0,0,"no");
SET("Analysis","viewport","viewport",0,0,"2 501 97 537");
SET("Core","active display","SUIT_enum",0,0,"\"bulletin board\" of {\"bulletin board\"}");
SET("Core","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("Core","has background","boolean",0,0,"no");
SET("Core","viewport","viewport",0,0,"2 358 212 495");
SET("Core: graphics","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("Core: graphics","background color","GP_color",0,0,"black, black");
SET("Core: graphics","has background","boolean",0,0,"no");
SET("Core: graphics","has border","boolean",0,0,"no");
SET("Core: graphics","viewport","viewport",0,0,"68 3 205 118");
SET("Core: text","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("Core: text","label","text",0,0,"Core");
SET("Core: text","viewport","viewport",0,0,"17 47 51 71");
SET("Core: colorbar","active display","SUIT_enum",0,0,"\"thermometer\" of {\"standard\" \"thermometer\"}");
SET("Core: colorbar","viewport","viewport",0,0,"5 120 205 134");
SET("Active","active display","SUIT_enum",0,0,"\"bulletin board\" of {\"bulletin board\"}");
SET("Active","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("Active","has background","boolean",0,0,"no");
SET("Active","viewport","viewport",0,0,"2 216 212 352");
SET("Active: graphics","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("Active: graphics","background color","GP_color",0,0,"black, black");
SET("Active: graphics","foreground color","GP_color",0,0,"white, black");
SET("Active: graphics","has background","boolean",0,0,"yes");
SET("Active: graphics","has border","boolean",0,0,"no");
SET("Active: graphics","viewport","viewport",0,0,"68 3 205 133");
SET("Active: text","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("Active: text","label","text",0,0,"Active");
SET("Active: text","viewport","viewport",0,0,"14 56 57 80");
SET("Fired","active display","SUIT_enum",0,0,"\"bulletin board\" of {\"bulletin board\"}");
SET("Fired","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("Fired","has background","boolean",0,0,"no");
SET("Fired","viewport","viewport",0,0,"2 73 212 210");
SET("Fired: graphics","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("Fired: graphics","background color","GP_color",0,0,"black, black");
SET("Fired: graphics","foreground color","GP_color",0,0,"white, black");
SET("Fired: graphics","has background","boolean",0,0,"yes");
SET("Fired: graphics","has border","boolean",0,0,"no");
SET("Fired: graphics","viewport","viewport",0,0,"68 3 205 134");
SET("Fired: text","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("Fired: text","label","text",0,0,"Fired");
SET("Fired: text","viewport","viewport",0,0,"17 56 54 80");
SET("main: menu: menu","active display","SUIT_enum",0,0,"\"vertical\" of {\"vertical\"}");
SET("main: menu: menu","stuck down","boolean",0,0,"no");
SET("main: menu: menu","viewport","viewport",0,0,"555 0 687 113");
SET("main: menu: menu","visible","boolean",0,0,"no");
SET("main: menu: load_auto","active display","SUIT_enum",0,0,"\"standard\" of {\"button with hotkey\" \"standard\"}");
SET("main: menu: load_auto","background color","GP_color",0,0,"blue, white");
SET("main: menu: load_auto","border type","SUIT_enum",0,0,"\"fancy motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("main: menu: load_auto","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: menu: load_auto","disabled","boolean",0,0,"no");
SET("main: menu: load_auto","foreground color","GP_color",0,0,"white, white");
SET("main: menu: load_auto","has border","boolean",0,0,"no");
SET("main: menu: load_auto","label","text",0,0,"LOAD ...");
SET("main: menu: load_auto","shrink to fit","boolean",0,0,"no");
SET("main: menu: load_auto","viewport","viewport",0,0,"4 86 128 111");
SET("main: menu: load_pgm_auto","active display","SUIT_enum",0,0,"\"standard\" of {\"button with hotkey\" \"standard\"}");
SET("main: menu: load_pgm_auto","border type","SUIT_enum",0,0,"\"fancy motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("main: menu: load_pgm_auto","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: menu: load_pgm_auto","disabled","boolean",0,0,"no");
SET("main: menu: load_pgm_auto","has border","boolean",0,0,"no");
SET("main: menu: load_pgm_auto","label","text",0,0,"LOAD @b((PGM)) ...");
SET("main: menu: load_pgm_auto","shrink to fit","boolean",0,0,"no");
SET("main: menu: load_pgm_auto","viewport","viewport",0,0,"4 58 128 82");
SET("main: menu: save_auto","active display","SUIT_enum",0,0,"\"standard\" of {\"button with hotkey\" \"standard\"}");
SET("main: menu: save_auto","background color","GP_color",0,0,"blue, white");
SET("main: menu: save_auto","border type","SUIT_enum",0,0,"\"fancy motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("main: menu: save_auto","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: menu: save_auto","disabled","boolean",0,0,"no");
SET("main: menu: save_auto","foreground color","GP_color",0,0,"white, white");
SET("main: menu: save_auto","has border","boolean",0,0,"no");
SET("main: menu: save_auto","label","text",0,0,"SAVE ...");
SET("main: menu: save_auto","shrink to fit","boolean",0,0,"no");
SET("main: menu: save_auto","viewport","viewport",0,0,"4 30 128 54");
SET("main: menu: save_pgm_auto","active display","SUIT_enum",0,0,"\"standard\" of {\"button with hotkey\" \"standard\"}");
SET("main: menu: save_pgm_auto","border type","SUIT_enum",0,0,"\"fancy motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("main: menu: save_pgm_auto","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: menu: save_pgm_auto","disabled","boolean",0,0,"no");
SET("main: menu: save_pgm_auto","has border","boolean",0,0,"no");
SET("main: menu: save_pgm_auto","label","text",0,0,"SAVE @b((PGM)) ...");
SET("main: menu: save_pgm_auto","shrink to fit","boolean",0,0,"no");
SET("main: menu: save_pgm_auto","viewport","viewport",0,0,"4 2 128 26");
SET("main","active display","SUIT_enum",0,0,"\"bulletin board\" of {\"bulletin board\"}");
SET("main","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main","viewport","viewport",0,0,"221 2 957 537");
SET("main: automata","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("main: automata","has background","boolean",0,0,"no");
SET("main: automata","viewport","viewport",0,0,"120 67 718 522");
SET("main: rlabel","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("main: rlabel","label","text",0,0,"Rows");
SET("main: rlabel","viewport","viewport",0,0,"13 21 52 45");
SET("main: clabel","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("main: clabel","label","text",0,0,"Cols");
SET("main: clabel","viewport","viewport",0,0,"126 21 159 45");
SET("main: rtype","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("main: rtype","altered","boolean",0,0,"no");
SET("main: rtype","calculate lines","boolean",0,0,"no");
SET("main: rtype","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: rtype","cursor x","int",0,0,"5");
SET("main: rtype","cursor y","int",0,0,"8");
SET("main: rtype","has a tab","boolean",0,0,"no");
SET("main: rtype","highlight block","boolean",0,0,"no");
SET("main: rtype","last mark index","int",0,0,"0");
SET("main: rtype","number of lines","int",0,0,"1");
SET("main: rtype","paint block only","boolean",0,0,"no");
SET("main: rtype","pre cursor index","int",0,0,"-1");
SET("main: rtype","read only","boolean",0,0,"no");
SET("main: rtype","start x","int",0,0,"5");
SET("main: rtype","start y","double",0,0,"19.000000");
SET("main: rtype","viewport","viewport",0,0,"64 21 101 45");
SET("main: slabel","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("main: slabel","label","text",0,0,"States");
SET("main: slabel","viewport","viewport",0,0,"241 21 284 45");
SET("main: ctype","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("main: ctype","altered","boolean",0,0,"no");
SET("main: ctype","calculate lines","boolean",0,0,"no");
SET("main: ctype","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: ctype","cursor x","int",0,0,"5");
SET("main: ctype","cursor y","int",0,0,"8");
SET("main: ctype","has a tab","boolean",0,0,"no");
SET("main: ctype","highlight block","boolean",0,0,"no");
SET("main: ctype","last mark index","int",0,0,"0");
SET("main: ctype","number of lines","int",0,0,"1");
SET("main: ctype","paint block only","boolean",0,0,"no");
SET("main: ctype","read only","boolean",0,0,"no");
SET("main: ctype","start x","int",0,0,"5");
SET("main: ctype","start y","double",0,0,"19.000000");
SET("main: ctype","viewport","viewport",0,0,"166 21 203 45");
SET("main: stype","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("main: stype","altered","boolean",0,0,"no");
SET("main: stype","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: stype","cut buffer","text",0,0,"");
SET("main: stype","has a tab","boolean",0,0,"no");
SET("main: stype","number of lines","int",0,0,"1");
SET("main: stype","paint block only","boolean",0,0,"no");
SET("main: stype","read only","boolean",0,0,"no");
SET("main: stype","viewport","viewport",0,0,"295 21 332 45");
SET("main: grid","active display","SUIT_enum",0,0,"\"motif square\" of {\"dot in circle\" \"check box\" \"motif diamond\" \"motif square\"}");
SET("main: grid","border type","SUIT_enum",0,0,"\"fancy motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("main: grid","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: grid","disabled","boolean",0,0,"no");
SET("main: grid","label","text",0,0,"Grid");
SET("main: grid","shrink to fit","boolean",0,0,"no");
SET("main: grid","viewport","viewport",0,0,"18 468 111 488");
SET("main: step","active display","SUIT_enum",0,0,"\"motif square\" of {\"dot in circle\" \"check box\" \"motif diamond\" \"motif square\"}");
SET("main: step","border type","SUIT_enum",0,0,"\"fancy motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("main: step","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: step","disabled","boolean",0,0,"no");
SET("main: step","label","text",0,0,"Step");
SET("main: step","shrink to fit","boolean",0,0,"no");
SET("main: step","viewport","viewport",0,0,"18 495 111 522");
SET("main: menu","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("main: menu","border type","SUIT_enum",0,0,"\"fancy motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("main: menu","has border","boolean",0,0,"yes");
SET("main: menu","label","text",0,0,"File..");
SET("main: menu","shrink to fit","boolean",0,0,"no");
SET("main: menu","viewport","viewport",0,0,"18 421 111 441");
SET("main: clear","active display","SUIT_enum",0,0,"\"standard\" of {\"button with hotkey\" \"standard\"}");
SET("main: clear","border type","SUIT_enum",0,0,"\"fancy motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("main: clear","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: clear","disabled","boolean",0,0,"no");
SET("main: clear","label","text",0,0,"Clear");
SET("main: clear","shrink to fit","boolean",0,0,"no");
SET("main: clear","viewport","viewport",0,0,"18 394 111 414");
SET("main: refresh","active display","SUIT_enum",0,0,"\"standard\" of {\"button with hotkey\" \"standard\"}");
SET("main: refresh","border type","SUIT_enum",0,0,"\"fancy motif\" of {\"simple\" \"motif\" \"fancy motif\"}");
SET("main: refresh","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: refresh","disabled","boolean",0,0,"no");
SET("main: refresh","label","text",0,0,"Refresh");
SET("main: refresh","shrink to fit","boolean",0,0,"no");
SET("main: refresh","viewport","viewport",0,0,"18 361 111 381");
SET("main: colorbar","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\" \"thermometer\"}");
SET("main: colorbar","viewport","viewport",0,0,"377 13 718 47");
SET("main: method","active display","SUIT_enum",0,0,"\"bulletin board\" of {\"bulletin board\"}");
SET("main: method","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: method","current row","int",0,0,"-1");
SET("main: method","current value","text",0,0,"");
SET("main: method","has background","boolean",0,0,"yes");
SET("main: method","label","text",0,0,"Rules");
SET("main: method","viewport","viewport",0,0,"18 67 111 341");
SET("main: method: scrollbar","active display","SUIT_enum",0,0,"\"scroll bar\" of {\"scroll bar\" \"vertical thermometer\" \"horizontal thermometer\" \"pie slice\" \"speedometer\"}");
SET("main: method: scrollbar","border raised","boolean",0,0,"no");
SET("main: method: scrollbar","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: method: scrollbar","current value","double",0,0,"0.000000");
SET("main: method: scrollbar","granularity","double",0,0,"1.000000");
SET("main: method: scrollbar","maximum value","double",0,0,"6.000000");
SET("main: method: scrollbar","minimum value","double",0,0,"0.000000");
SET("main: method: scrollbar","percent full","double",0,0,"0.714286");
SET("main: method: scrollbar","springiness","SUIT_springiness",0,0,"17");
SET("main: method: scrollbar","viewport","viewport",0,0,"79 2 91 272");
SET("main: method: scrollbar: first arrow","active display","SUIT_enum",0,0,"\"motif\" of {\"simple arrow\" \"motif\"}");
SET("main: method: scrollbar: first arrow","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: method: scrollbar: first arrow","direction","SUIT_enum",0,0,"\"up\" of {\"up\" \"down\" \"left\" \"right\"}");
SET("main: method: scrollbar: first arrow","has border","boolean",0,0,"no");
SET("main: method: scrollbar: first arrow","viewport","viewport",0,0,"0 258 12 270");
SET("main: method: scrollbar: elevator","active display","SUIT_enum",0,0,"\"motif\" of {\"motif\"}");
SET("main: method: scrollbar: elevator","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: method: scrollbar: elevator","current value","double",0,0,"0.000000");
SET("main: method: scrollbar: elevator","has border","boolean",0,0,"no");
SET("main: method: scrollbar: elevator","percent full","double",0,0,"0.714286");
SET("main: method: scrollbar: elevator","viewport","viewport",0,0,"0 12 12 258");
SET("main: method: scrollbar: second arrow","active display","SUIT_enum",0,0,"\"motif\" of {\"simple arrow\" \"motif\"}");
SET("main: method: scrollbar: second arrow","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: method: scrollbar: second arrow","direction","SUIT_enum",0,0,"\"down\" of {\"up\" \"down\" \"left\" \"right\"}");
SET("main: method: scrollbar: second arrow","has border","boolean",0,0,"no");
SET("main: method: scrollbar: second arrow","viewport","viewport",0,0,"0 0 12 12");
SET("main: method: list","active display","SUIT_enum",0,0,"\"standard\" of {\"standard\"}");
SET("main: method: list","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("main: method: list","drawing viewport","viewport",0,0,"-14 2 69 256");
SET("main: method: list","springiness","SUIT_springiness",0,0,"3");
SET("main: method: list","viewport","viewport",0,0,"-14 2 69 272");
SET("Cellular Automata Simulator","active display","SUIT_enum",0,0,"\"standard\" of {\"button with hotkey\" \"standard\"}");
SET("Cellular Automata Simulator","callback function","SUIT_functionPointer",0,0,"function ptr");
SET("Cellular Automata Simulator","disabled","boolean",0,0,"no");
SET("Cellular Automata Simulator","font","GP_font",0,0,"new century schoolbook,bolditalic,24.000000");
SET("Cellular Automata Simulator","label","text",0,0,"Cellular Automata Simulator");
SET("Cellular Automata Simulator","shrink to fit","boolean",0,0,"no");
SET("Cellular Automata Simulator","viewport","viewport",0,0,"21 549 937 585");


} /* end of INIT_suiRoutine */



void SUIT_initFromCode (char *programName)
{
    SUIT_interiorInitFromCode (programName, INIT_suiRoutine, THE_SCREEN_WIDTH,
                               THE_SCREEN_HEIGHT, THE_SCREEN_DEPTH);
}
