#include "auto.h"
#include "patchlevel.h"


void common_save (
	  char *label, SUIT_object obj, FILE ** fp, SUIT_object * auto_obj);
void common_load (
	  char *label, SUIT_object obj, FILE ** fp, SUIT_object * auto_obj);

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:	adjust_cols					*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void
  adjust_cols (SUIT_object obj)
{
  SUIT_object parent, auto_obj;
  int cols;
  int actual_rows, actual_cols;

  parent = SUIT_getParent (obj);
  auto_obj = SUIT_getObject (parent, AUTOMATON);

  cols = atoi (SUIT_getText (obj, CURRENT_VALUE));
  actual_rows = SUIT_getInteger (auto_obj, ROWS);
  actual_cols = SUIT_getInteger (auto_obj, COLUMNS);

  if (cols > 0)
  {
    if (cols != actual_cols)
      reset_row_col (auto_obj, actual_rows, cols);
  }
  else
    SUIT_inform ( "Invalid number of columns\nMust be positive");

  do_state_typein (auto_obj);
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void
  adjust_rows (SUIT_object obj)
{
  SUIT_object parent, auto_obj;
  int rows;
  int actual_rows, actual_cols;

  parent = SUIT_getParent (obj);
  auto_obj = SUIT_getObject (parent, AUTOMATON);

  rows = atoi (SUIT_getText (obj, CURRENT_VALUE));
  actual_rows = SUIT_getInteger (auto_obj, ROWS);
  actual_cols = SUIT_getInteger (auto_obj, COLUMNS);

  if (rows > 0)
  {
    if (rows != actual_rows)
      reset_row_col (auto_obj, rows, actual_cols);
  }
  else
    SUIT_inform(
        "Invalid number of rows\n"
	"Must be greater than @b(0)");

  do_state_typein (auto_obj);
}



/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void
  adjust_states (SUIT_object obj)
{
  int states, rows, cols;
  int row, col, item;
  SUIT_object parent, auto_obj;
  automaton automata;
  char buffer[200];


  states = atoi (SUIT_getText (obj, CURRENT_VALUE));
  parent = SUIT_getParent (obj);
  auto_obj = SUIT_getObject (parent, AUTOMATON);

  if ((states > 0) && (states <= MAX_STATES))
  {

    rows = SUIT_getInteger (auto_obj, ROWS);
    cols = SUIT_getInteger (auto_obj, COLUMNS);
    automata = SUITx_getVoidPtr (auto_obj, AUTOMATON);

    SUIT_setInteger (auto_obj, STATES, states);

    item = 0;
    for (row = 0; row < rows; row++)
      for (col = 0; col < cols; col++)
      {
	if (automata[item].state > states)
	{
	  automata[item].state = states;
	  automata[item].changed = TRUE;
	}
	else if (automata[item].state > 0)
	  automata[item].changed = TRUE;
      }
  }
  else
  {
    sprintf
      (
	buffer,
	"Invalid number of states\nMust be in range 1<->%d",
	MAX_STATES
      );
    SUIT_inform (buffer);
  }

  do_state_typein (auto_obj);

  SUIT_paintObject (obj);
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void
  change_analysis (SUIT_object obj)
{

  analysis = SUIT_getBoolean (obj, CURRENT_VALUE);

  SUIT_paintObject (fired_obj);
  SUIT_paintObject (active_obj);

  if (analysis)
    paint_all_matrix = TRUE;

  SUIT_paintObject (core_obj);

  if (analysis)
    paint_all_matrix = FALSE;
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
* Function name:
*
* Description:
*
* Date of creation:
*
* input arguments:
*
* output:
*
* function return:
*
* Modifications:
*
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void clear_analysis(SUIT_object obj)
{
   resetPerfmeter (fired_obj);
   resetPerfmeter (active_obj);
   resetMatrix (core_obj);
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void
  change_grid (SUIT_object obj)
{
  SUIT_object parent, auto_obj;
  int grid;

  parent = SUIT_getParent (obj);
  auto_obj = SUIT_getObject (parent, AUTOMATON);


  grid = SUIT_getBoolean (obj, CURRENT_VALUE);
  SUIT_setBoolean (auto_obj, GRID, grid);

  if (!grid)
  {
    SUIT_setBoolean (auto_obj, HAS_BACKGROUND, TRUE);
    paint_all = TRUE;
  }

  SUIT_paintObject (auto_obj);

  if (!grid)
  {
    SUIT_setBoolean (auto_obj, HAS_BACKGROUND, FALSE);
    paint_all = FALSE;
  }
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void
  change_step (SUIT_object obj)
{
  SUIT_object parent, auto_obj;
  int grid;

  parent = SUIT_getParent (obj);
  auto_obj = SUIT_getObject (parent, AUTOMATON);

  grid = SUIT_getBoolean (obj, CURRENT_VALUE);
  SUIT_setBoolean (auto_obj, STEP, grid);

  SUIT_paintObject (obj);
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void load_auto (SUIT_object obj)
{
  FILE *fp;
  SUIT_object auto_obj;

  common_load ("select file", obj, &fp, &auto_obj);
  if (fp)
  {
    if (load_auto_data (fp, auto_obj))
    {
      do_state_typein (auto_obj);
      SUIT_paintObject (auto_obj);
    }
    else
      SUIT_inform ("error loading automaton data");
    fclose (fp);
  }
}


void load_pgm_auto (SUIT_object obj)
{
  FILE *fp;
  SUIT_object auto_obj;

  common_load ("select PGM file", obj, &fp, &auto_obj);
  if (fp)
  {
    if (load_pgm_data (fp, auto_obj))
    {
      do_state_typein (auto_obj);
      SUIT_paintObject (auto_obj);
    }
    else
      SUIT_inform ("error loading automaton data");
    fclose (fp);
  }
}


void common_load (char *label, SUIT_object obj, FILE ** fp, SUIT_object * auto_obj)
{
  char *fname;
  SUIT_object parent;

  *fp = NULL;
  fname = SUIT_askForFileName (".", "LOAD", label);
  if (fname)
  {
    *fp = fopen (fname, "r");
    if (*fp)
    {
      parent = SUITx_getAncestor (obj);
      *auto_obj = SUIT_getObject (parent, AUTOMATON);

    }
    else
      SUIT_inform ("File does not exist");
  }
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void clear_auto (SUIT_object obj)
{
  SUIT_object parent, auto_obj;
  int rows, cols;
  automaton automata;

  parent = SUIT_getParent (obj);
  auto_obj = SUIT_getObject (parent, AUTOMATON);
  automata = SUITx_getVoidPtr (auto_obj, AUTOMATON);
  rows = SUIT_getInteger (auto_obj, ROWS);
  cols = SUIT_getInteger (auto_obj, COLUMNS);

  InitAutomaton (automata);
  ClearAutomatonStacks (auto_obj);


  SUIT_paintObject (auto_obj);
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
* Function name:
*
* Description:
*
* Date of creation:
*
* input arguments:
*
* output:
*
* function return:
*
* Modifications:
*
- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void refresh_auto(SUIT_object obj)
{
  SUIT_object parent, auto_obj;

  parent = SUIT_getParent (obj);
  auto_obj = SUIT_getObject (parent, AUTOMATON);

  SUIT_paintObject(auto_obj);
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:	save_auto, save_pgm_auto, common_save		*/
/*									*/
/* Description:		interface to save files.			*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:	various						*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void save_auto (SUIT_object obj)
{
  SUIT_object auto_obj;
  FILE *fp;

  common_save ("select filename", obj, &fp, &auto_obj);
  if (fp)
  {
    save_auto_data (fp, auto_obj);
    fclose (fp);
  }
}

void save_pgm_auto (SUIT_object obj)
{
  SUIT_object auto_obj;
  FILE *fp;

  common_save ("select PGM filename", obj, &fp, &auto_obj);
  if (fp)
  {
    save_pgm_data (fp, auto_obj);
    fclose (fp);
  }
}

void common_save (char *label, SUIT_object obj, FILE ** fp, SUIT_object * auto_obj)
{
  char *fname, *SUIT_fname;
  char buffer[BUFFER_SIZE];
  int go_ahead = TRUE;
  SUIT_object parent;

  SUIT_fname = SUIT_askForFileName (".", "SAVE", label);

  if (SUIT_fname)
  {
    fname = strdup (SUIT_fname);

    if (exists (fname))
    {
      sprintf (buffer, "Overwrite file @b(%s) ?", fname);
      if (SUIT_askYesNo (buffer) == REPLY_NO)
      {
	SUIT_inform ("Save Aborted");
	go_ahead = FALSE;
      }
    }

    if (go_ahead)
    {
      *fp = fopen (fname, "w");
      if (*fp)
      {
	/*
	   for some peculiar reason the file menu (when activated) can
	   remember its parent. It skips all the way back to root. So the
	   graphics widget must be located by hand

	   This is probably because the menubutton creates a new object
	   of name menubutton:menu (this explains somethings) which is
	   not treated as the child of the menubutton. (naughty)

	   essentially CHILD objects must fit entirely within the parent
	   according to SUIT This cant happen if a bigger object is generated.

	   the names are organised heirarchically so lets cheat
	*/
	parent = SUITx_getAncestor (obj);
	*auto_obj = SUIT_getObject (parent, AUTOMATON);

      }
      else
	SUIT_inform ("Error opening file");
    }

    free (fname);
  }
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void do_method (SUIT_object obj)
{
  SUIT_object parent, abort_obj, auto_obj;
  int rows, cols, grid;
  DynArray objs;
  char *label;
  rule *current_rule;
  fn_ptr callback = NULL;
  automaton automata;

  int changed = 99999;
  int aborted = FALSE;
  int step;
  int found = FALSE;

  stack display_stack, update_stack;

  /* ----------------------------------------------------------------	*/
  /* get some properties for use later on				*/
  /* ----------------------------------------------------------------	*/
  parent = SUIT_getParent (obj);
  auto_obj = SUIT_getObject (parent, AUTOMATON);
  rows = SUIT_getInteger (auto_obj, ROWS);
  cols = SUIT_getInteger (auto_obj, COLUMNS);
  grid = SUIT_getBoolean (auto_obj, GRID);
  step = SUIT_getBoolean (auto_obj, STEP);

  SUIT_setBoolean (auto_obj, GRID, FALSE);
  SUIT_paintObject (auto_obj);
  SUIT_setBoolean (done_obj, DISABLED, TRUE);

  /* ----------------------------------------------------------------	*/
  /* put an abort widget on the screen					*/
  /* SUIT insists on using DynArrays so set_object_to_check		*/
  /* also make sure that only the cells that need to be painted are	*/
  /* ----------------------------------------------------------------	*/
  label = SUIT_getText (obj, CURRENT_VALUE);
  while (*label == ' ')
    label++;

  abort_obj = CreateAbortWidget (label);
  setchildsize (abort_obj, 0.12, 0.0, 0.22, 0.10);
  SUIT_paintObject (abort_obj);

  objs = set_object_to_check (abort_obj);
  paint_all = 0;


  /* ----------------------------------------------------------------	*/
  /* determine which method to use.. its in the form of a string at the */
  /* moment and I dont want to have to do a strcmp everytime, so convert*/
  /* string to function pointer here.					*/
  /* ----------------------------------------------------------------	*/
  current_rule = rule_array;
  while ((!found) && current_rule)
  {
    if (strcmp (label, current_rule->name) == 0)
    {
      found = TRUE;
      callback = current_rule->callback;
    }
    else
      current_rule++;
  }

  /* ----------------------------------------------------------------	*/
  /* whilst cells in the automata have changed, and the user hasnt	*/
  /* selected ABORT, execute the automata				*/
  /* ----------------------------------------------------------------	*/
  automata = SUITx_getVoidPtr (auto_obj, AUTOMATON);
  display_stack = SUITx_getVoidPtr (auto_obj, DISPLAY_STACK);
  update_stack = SUITx_getVoidPtr (auto_obj, UPDATE_STACK);

  while ((changed > 0) && !aborted && found && callback)
  {
    changed = step_method (callback, automata, rows, cols,
			   &display_stack, &update_stack);

    /* ----------------------------------------------------------------	*/
    /* update display and update stack before repainting		*/
    /* ----------------------------------------------------------------	*/
    SUITx_setVoidPtr(auto_obj,DISPLAY_STACK,display_stack);
    SUITx_setVoidPtr(auto_obj,UPDATE_STACK,update_stack);


    /* ----------------------------------------------------------------	*/
    /* set properties of dependant objects				*/
    /* ----------------------------------------------------------------	*/
    SUIT_setInteger (active_obj, NEW_DATA, active);
    SUIT_setBoolean (active_obj, HAS_NEW_DATA, TRUE);

    SUIT_setInteger (fired_obj, NEW_DATA, changed);
    SUIT_setBoolean (fired_obj, HAS_NEW_DATA, TRUE);

    SUIT_setBoolean (core_obj, REPAINT, TRUE);

    SUIT_paintObject (auto_obj);

    /* ----------------------------------------------------------------	*/
    if (step)
      aborted = TRUE;
    else if (changed > 0)
    {
      SUIT_limitedCheckAndProcessInput (WAIT_TIME, objs);
      aborted = SUIT_getBoolean (abort_obj, ABORTED);
    }
  }


  /* ----------------------------------------------------------------	*/
  /* abort widget isnt needed,  grid and exit should be restored 	*/
  /* restore painting of all the cells				*/
  /* ----------------------------------------------------------------	*/
  SUIT_destroyObject (abort_obj);
  SUIT_setBoolean (auto_obj, GRID, grid);
  SUIT_setBoolean (done_obj, DISABLED, FALSE);

  DynDestroy (objs);
  paint_all = 1;
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:							*/
/*									*/
/* Description:								*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void about (SUIT_object obj)
{
  SUIT_inform
  (
    "@c(Cellular Automata Simulator)\n\n"
    "@c(Version " PATCHLEVEL " )\n\n"
    "@c(by Sunil Gupta, cs89ssg@@uk.ac.brunel)\n\n"
    PROGRAM " version " PATCHLEVEL " Copyright (C) 1993 Sunil Gupta\n\n"
    PROGRAM " comes with ABSOLUTELY NO WARRANTY \n"
    "This is free software, and you are welcome to redistribute it\n"
    "under certain conditions\n"
    "See the file LICENSE for more details\n"
  );
}
