#include "auto.h"


/************************************************************************/
/*				GLOBALS					*/
/************************************************************************/
SUIT_object auto_obj, done_obj;
SUIT_object fired_obj, active_obj, core_obj;

int analysis = FALSE;



/************************************************************************/
/*			PRIVATE FUNCTIONS				*/
/************************************************************************/

void main (int argc, char *argv[]);
void setup_interface (void);



/************************************************************************/
/*			THE FUNCTIONS					*/
/************************************************************************/

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:	main						*/
/*									*/
/* Description:		starts the whole process			*/
/*									*/
/* Date of creation:	29-01-93					*/
/*									*/
/* input arguments:	None						*/
/*									*/
/* output:		None						*/
/*									*/
/* function return:	void						*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void main (int argc, char *argv[])
{

  /* ------------------------------------------------------------------	*/
  /* read the sui file and register any userdefined types		*/
  /* ------------------------------------------------------------------	*/

#  ifdef INSTALL
  SUIT_initFromCode (argv[0]);
#  else
  SUIT_init (argv[0]);
#  endif

  SUITx_InitVoidPtrType ();
  GP_setMarkerStyle (MARKER_X);
  GP_setMarkerSize (3);

  /* ------------------------------------------------------------------	*/
  /* ------------------------------------------------------------------	*/
# ifdef DEBUG
    puts("Debugging is on");
# else
    puts("Debugging is off");
# endif
  setup_interface ();
  GNU_thing ();
  SUIT_beginStandardApplication ();
}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:	setup_interface					*/
/*									*/
/* Description:		creates SUIT objects needed for application	*/
/*									*/
/* Date of creation:	29-01-93					*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
void setup_interface ()
{
  SUIT_object title, automat, analysis_obj, clear_analysis_obj;

  fired_obj = active_obj = core_obj = (SUIT_object) NULL;

  /* ----------------------------------------------------------------- */

  title = SUIT_createButton ("Cellular Automata Simulator", about);
  setfont (title, "new century schoolbook", "bolditalic", 24.0);
  SUIT_setBoolean (title, SHRINK_TO_FIT, FALSE);
  setchildsize (title, 0.02, 0.92, 0.98, 0.98);

  /* ----------------------------------------------------------------- */

  automat = auto_obj = CreateAutomataWidget ("main");
  setchildsize (automat, 0.23, 0.0, 1.0, 0.90);


  fired_obj = CreateLineGraphWidget ("Fired", NULL);
  setchildsize (fired_obj, 0.0, 0.12, 0.22, 0.35);

  active_obj = CreateLineGraphWidget ("Active", NULL);
  setchildsize (active_obj, 0.0, 0.36, 0.22, 0.59);

  core_obj = CreateMatrixWidget ("Core", automat);
  setchildsize (core_obj, 0.0, 0.60, 0.22, 0.83);

  /* ----------------------------------------------------------------- */
  analysis_obj = SUIT_createOnOffSwitch ("Analysis", change_analysis);
  SUIT_setBoolean (analysis_obj, SHRINK_TO_FIT, FALSE);
  SUIT_setBoolean (analysis_obj, CURRENT_VALUE, analysis);
  setchildsize (analysis_obj, 0.0, 0.84, 0.10, 0.90);

  clear_analysis_obj = SUIT_createButton("Clear Analysis", clear_analysis);
  SUIT_setBoolean (clear_analysis_obj, SHRINK_TO_FIT, FALSE);
  setchildsize (clear_analysis_obj, 0.12, 0.84, 0.22 , 0.90);


  /* ----------------------------------------------------------------- */
  done_obj = SUIT_createDoneButton (NULL);
  SUIT_setText (done_obj, LABEL, "EXIT");
  SUIT_setBoolean (done_obj, SHRINK_TO_FIT, FALSE);
  setchildsize (done_obj, 0.0, 0.00, 0.10, 0.10);
}
