/**************************************************************************
 I wrote this code a while ago and as far as I know it works (I use it often
-=- however I don't remember if this is all that is needed... you are welcome
to try it!)

It is modeled on the the suit code from deftypes.c.

--
Stephen Gaito,  Ecosystems Analysis and Management Group, Biological Sciences,
                Univ.  of Warwick, Coventry, CV4 7AL ---
                Phone: +44 (203) 524456
                Email: stg@oikos.warwick.ac.uk
                Email: stg@uk.ac.warwick.oikos (on JANET)

***************************************************************************/

/* (C) Copyright 1990, 1991, 1992 the University of Virginia */

#define	myDebug(message)
/*{ printf message; fflush(stdout); }*/

#include "suitx.h"

/*--------------------------------------------------------*/
/*   VoidPtr data type					  */

void SUITx_setVoidPtr (SUIT_object obj, char *name, void *Ptrvalue)
{
  ASSERT (
	   (obj != NULL),
	   (mes,
	    "SUITx_setVoidPtr was called with a NULL object.\n" \
	    "Use SUIT_deluxeSetProperty to set global properties.\n"
	   )
  );
  SUIT_setProperty (obj, name, "VoidPtr", (Pointer) & Ptrvalue, OBJECT);
}

void *SUITx_getVoidPtr (SUIT_object obj, char *name)
{
  return ((*(void **) SUIT_getProperty (obj, name, "VoidPtr")));
}


PRIVATE Pointer ReadVoidPtr (char *unused, boolean * error)
{
  ASSERT (
	   FALSE, (
		    mes,
		    "application's .sui file contains a reference to a\n" \
		    "* property of type void *.These MUST be temporary."
	   )
  );

  *error = TRUE;
  return NULL;
}


PRIVATE char *WriteVoidPtr (Pointer unused)
{
  return "VoidPtr";
}


PRIVATE
int CompareVoidPtr (Pointer aVoidPtr1, Pointer aVoidPtr2)
{
  void *one = *(void **) aVoidPtr1;
  void *two = *(void **) aVoidPtr2;

  return (unsigned long) one - (unsigned long) two;
}

PRIVATE
void DestroyVoidPtr (Pointer aVoidPtr)
{
  SUIT_free (aVoidPtr);
}


PRIVATE
Pointer CopyVoidPtr (Pointer val)
{
  return SUIT_copyData (val, sizeof (void *));
}

PRIVATE
Pointer DefaultVoidPtr (void)
{
  return (Pointer) 0;
};

void SUITx_InitVoidPtrType (void)
{
  myDebug ("SUITx_InitVoidPtrType\n");

  SUIT_registerType (
		      "VoidPtr",
		      ReadVoidPtr,
		      WriteVoidPtr,
		      CompareVoidPtr,
		      DestroyVoidPtr,
		      CopyVoidPtr,
		      DefaultVoidPtr,
		      NULL
    );
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
/* Function name:	SUITx_getAncestor				*/
/*									*/
/* Description:		uses the name of an heirarchical object,	*/
/*			(assumes created using SUIT_relativeName) to 	*/
/*			get first object in heirarchy.			*/
/*			null if parent is root				*/
/*									*/
/* Date of creation:							*/
/*									*/
/* input arguments:							*/
/*									*/
/* output:								*/
/*									*/
/* function return:							*/
/*									*/
/* Modifications:							*/
/*									*/
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/
SUIT_object SUITx_getAncestor (SUIT_object obj)
{
  char buffer[100];
  char *cp;
  SUIT_object retval = NULL;

  sprintf (buffer, "%s", OBJECT_NAME (obj));
  cp = strchr (buffer, ':');
  if (cp)
  {
    *cp = 0;
    retval = SUIT_name (buffer);
  }
  return (retval);
}
